<template>
  <div class="container--main">
    <SubTitle class="container--main" v-if="getWidth > 768" title="Latest Updated" />
    <ul>
      <li v-for="card in getCards" :key="card.id" class="pb-1">
        <CardItem :cardData="card" :categories="resolveCategories(card.categories, card.showAllCategories)" :toggleMoreSections="toggleMoreSections" />
      </li>
    </ul>
    <footer class="viewmore-sec">
      <span class="btn">VIEW MORE</span>
    </footer>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';
import CardItem from '@/components/organisms/CardItem.vue';
import SubTitle from '@/components/atoms/SubTitle.vue';

export default {
  name: 'MainSection',
  components: {
    CardItem,
    SubTitle,
  },
  data() {
    return {
      showAllItems: false,
    };
  },
  computed: {
    ...mapGetters(['getCards', 'showAllCategories', 'getWidth']),
  },
  methods: {
    ...mapActions(['toggleCategoriesById']),
    toggleMoreSections(id) {
      this.toggleCategoriesById(id);
    },
    resolveCategories(val, categories) {
      return categories ? val : val.filter((item) => item.hidden);
    },
  },
};
</script>

<style lang="sass" scoped>
@import '@/assets/sass/colors.sass'
@import '@/assets/sass/sizes.sass'
.container--main
  padding-bottom: 3rem
ul
  display: grid
  gap: .4rem
  grid-template-columns: repeat(auto-fill, minmax(19rem, 1fr))
.container--main
  text-align: left
  padding-bottom: 1.5rem
  font-weight: 400
.pb-1
  padding-bottom: .7rem
footer
  padding: 2rem 0
.btn
  padding: .4em $sm-size
  background: $primary-ligth
  color: $secondary
  border-radius: .5rem
  font-weight: 500
  cursor: pointer
.viewmore-sec
  text-align: center
</style>
